package jp.co.yahoo.hadoop.common;

import java.io.IOException;

import org.apache.hadoop.io.BytesWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.mapreduce.InputSplit;
import org.apache.hadoop.mapreduce.RecordReader;
import org.apache.hadoop.mapreduce.TaskAttemptContext;

/**
 * An CombineFileInputFormat that can handle whole contents of a file at one time.
 */
public class CombineWholeFileInputFormat extends
		CombineFileInputFormat<NullWritable, BytesWritable> {
	@Override
	public RecordReader<NullWritable, BytesWritable> createRecordReader(
			InputSplit split, TaskAttemptContext context) throws IOException {
		return new CombineFileRecordReader<NullWritable, BytesWritable>(
				(CombineFileSplit) split, context, CombineWholeFileRecordReader.class);
	}
}