package jp.co.yahoo.hadoop.ml.regression;

import jp.co.yahoo.hadoop.ml.common.CommonUtil;
import jp.co.yahoo.hadoop.ml.common.DiscriminantFunctionAlgorithm;

import org.apache.hadoop.io.MapWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.io.VIntWritable;

/**
 * A test class for regression.
 */
public class TestRegression {
	public static void main(String[] args) throws Exception {
		if (args.length < 2) {
			System.err
					.println("Usage: cmd <test file> <train file> [algorithm]");
			return;
		}

		String algorithm = "liner";
		if (args.length >= 3)
			algorithm = args[2];

		MapWritable testMap = CommonUtil.readTestFile(args[0]);
		MapWritable weightMap = CommonUtil.readWeightFile(args[1]);
		
		testMap.put(new Text(CommonUtil.BIAS_KEY), new VIntWritable(1));

		double age = 0;
		if (algorithm.equals("log")) {
			age = DiscriminantFunctionAlgorithm.predictLogistic(testMap,
					weightMap, CommonUtil.MAX_AGE);
		} else {
			age = DiscriminantFunctionAlgorithm.predict(testMap, weightMap);
		}

		if (age > CommonUtil.MAX_AGE)
			age = CommonUtil.MAX_AGE;
		if (age < 0)
			age = 0;

		System.out.println("あなたは" + age + "歳で死ぬでしょう。");
	}
}